# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ApiLicenseDetailsXO(BaseModel):
    """
    ApiLicenseDetailsXO
    """ # noqa: E501
    contact_company: Optional[StrictStr] = Field(default=None, alias="contactCompany")
    contact_email: Optional[StrictStr] = Field(default=None, alias="contactEmail")
    contact_name: Optional[StrictStr] = Field(default=None, alias="contactName")
    effective_date: Optional[datetime] = Field(default=None, alias="effectiveDate")
    expiration_date: Optional[datetime] = Field(default=None, alias="expirationDate")
    features: Optional[StrictStr] = None
    fingerprint: Optional[StrictStr] = None
    license_type: Optional[StrictStr] = Field(default=None, alias="licenseType")
    licensed_users: Optional[StrictStr] = Field(default=None, alias="licensedUsers")
    max_repo_components: Optional[StrictInt] = Field(default=None, alias="maxRepoComponents")
    max_repo_requests: Optional[StrictInt] = Field(default=None, alias="maxRepoRequests")
    __properties: ClassVar[List[str]] = ["contactCompany", "contactEmail", "contactName", "effectiveDate", "expirationDate", "features", "fingerprint", "licenseType", "licensedUsers", "maxRepoComponents", "maxRepoRequests"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ApiLicenseDetailsXO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ApiLicenseDetailsXO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contactCompany": obj.get("contactCompany"),
            "contactEmail": obj.get("contactEmail"),
            "contactName": obj.get("contactName"),
            "effectiveDate": obj.get("effectiveDate"),
            "expirationDate": obj.get("expirationDate"),
            "features": obj.get("features"),
            "fingerprint": obj.get("fingerprint"),
            "licenseType": obj.get("licenseType"),
            "licensedUsers": obj.get("licensedUsers"),
            "maxRepoComponents": obj.get("maxRepoComponents"),
            "maxRepoRequests": obj.get("maxRepoRequests")
        })
        return _obj


