# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DockerHostedStorageAttributes(BaseModel):
    """
    DockerHostedStorageAttributes
    """ # noqa: E501
    blob_store_name: StrictStr = Field(description="Blob store used to store repository contents", alias="blobStoreName")
    latest_policy: Optional[StrictBool] = Field(default=None, description="Whether to allow redeploying the 'latest' tag but defer to the Deployment Policy for all other tags", alias="latestPolicy")
    strict_content_type_validation: StrictBool = Field(description="Whether to validate uploaded content's MIME type appropriate for the repository format", alias="strictContentTypeValidation")
    write_policy: StrictStr = Field(description="Controls if deployments of and updates to assets are allowed", alias="writePolicy")
    __properties: ClassVar[List[str]] = ["blobStoreName", "latestPolicy", "strictContentTypeValidation", "writePolicy"]

    @field_validator('write_policy')
    def write_policy_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['allow', 'allow_once', 'deny']):
            raise ValueError("must be one of enum values ('allow', 'allow_once', 'deny')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DockerHostedStorageAttributes from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DockerHostedStorageAttributes from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "blobStoreName": obj.get("blobStoreName"),
            "latestPolicy": obj.get("latestPolicy"),
            "strictContentTypeValidation": obj.get("strictContentTypeValidation"),
            "writePolicy": obj.get("writePolicy")
        })
        return _obj


