# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from nexus_api_client.models.blob_store_api_soft_quota import BlobStoreApiSoftQuota
from typing import Optional, Set
from typing_extensions import Self

class GroupBlobStoreApiModel(BaseModel):
    """
    GroupBlobStoreApiModel
    """ # noqa: E501
    fill_policy: Optional[StrictStr] = Field(default=None, alias="fillPolicy")
    members: Optional[List[StrictStr]] = Field(default=None, description="List of the names of blob stores that are members of this group")
    soft_quota: Optional[BlobStoreApiSoftQuota] = Field(default=None, alias="softQuota")
    __properties: ClassVar[List[str]] = ["fillPolicy", "members", "softQuota"]

    @field_validator('fill_policy')
    def fill_policy_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['roundRobin', 'writeToFirst']):
            raise ValueError("must be one of enum values ('roundRobin', 'writeToFirst')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GroupBlobStoreApiModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of soft_quota
        if self.soft_quota:
            _dict['softQuota'] = self.soft_quota.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GroupBlobStoreApiModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fillPolicy": obj.get("fillPolicy"),
            "members": obj.get("members"),
            "softQuota": BlobStoreApiSoftQuota.from_dict(obj["softQuota"]) if obj.get("softQuota") is not None else None
        })
        return _obj


