# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class S3BlobStoreApiBucketSecurity(BaseModel):
    """
    S3BlobStoreApiBucketSecurity
    """ # noqa: E501
    access_key_id: Optional[StrictStr] = Field(default=None, description="An IAM access key ID for granting access to the S3 bucket", alias="accessKeyId")
    role: Optional[StrictStr] = Field(default=None, description="An IAM role to assume in order to access the S3 bucket")
    secret_access_key: Optional[StrictStr] = Field(default=None, description="The secret access key associated with the specified IAM access key ID", alias="secretAccessKey")
    session_token: Optional[StrictStr] = Field(default=None, description="An AWS STS session token associated with temporary security credentials which grant access to the S3 bucket", alias="sessionToken")
    __properties: ClassVar[List[str]] = ["accessKeyId", "role", "secretAccessKey", "sessionToken"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of S3BlobStoreApiBucketSecurity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of S3BlobStoreApiBucketSecurity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accessKeyId": obj.get("accessKeyId"),
            "role": obj.get("role"),
            "secretAccessKey": obj.get("secretAccessKey"),
            "sessionToken": obj.get("sessionToken")
        })
        return _obj


