# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SupportZipGeneratorRequest(BaseModel):
    """
    SupportZipGeneratorRequest
    """ # noqa: E501
    archived_log: Optional[StrictInt] = Field(default=None, alias="archivedLog")
    audit_log: Optional[StrictBool] = Field(default=None, alias="auditLog")
    configuration: Optional[StrictBool] = None
    hostname: Optional[StrictStr] = None
    jmx: Optional[StrictBool] = None
    limit_file_sizes: Optional[StrictBool] = Field(default=None, alias="limitFileSizes")
    limit_zip_size: Optional[StrictBool] = Field(default=None, alias="limitZipSize")
    log: Optional[StrictBool] = None
    metrics: Optional[StrictBool] = None
    replication: Optional[StrictBool] = None
    security: Optional[StrictBool] = None
    system_information: Optional[StrictBool] = Field(default=None, alias="systemInformation")
    task_log: Optional[StrictBool] = Field(default=None, alias="taskLog")
    thread_dump: Optional[StrictBool] = Field(default=None, alias="threadDump")
    __properties: ClassVar[List[str]] = ["archivedLog", "auditLog", "configuration", "hostname", "jmx", "limitFileSizes", "limitZipSize", "log", "metrics", "replication", "security", "systemInformation", "taskLog", "threadDump"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SupportZipGeneratorRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SupportZipGeneratorRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "archivedLog": obj.get("archivedLog"),
            "auditLog": obj.get("auditLog"),
            "configuration": obj.get("configuration"),
            "hostname": obj.get("hostname"),
            "jmx": obj.get("jmx"),
            "limitFileSizes": obj.get("limitFileSizes"),
            "limitZipSize": obj.get("limitZipSize"),
            "log": obj.get("log"),
            "metrics": obj.get("metrics"),
            "replication": obj.get("replication"),
            "security": obj.get("security"),
            "systemInformation": obj.get("systemInformation"),
            "taskLog": obj.get("taskLog"),
            "threadDump": obj.get("threadDump")
        })
        return _obj


