# coding: utf-8

"""
    Sonatype Nexus Repository Manager

    This documents the available APIs into [Sonatype Nexus Repository Manager](https://www.sonatype.com/products/sonatype-nexus-repository) as of version 3.81.1-01.

    The version of the OpenAPI document: 3.81.1-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from nexus_api_client.models.system_check_result_dto import SystemCheckResultDTO
from typing import Optional, Set
from typing_extensions import Self

class SystemCheckResultsApiDTO(BaseModel):
    """
    SystemCheckResultsApiDTO
    """ # noqa: E501
    hostname: Optional[StrictStr] = Field(default=None, description="The hostname of the originating node")
    node_id: Optional[StrictStr] = Field(default=None, description="A unique identifier for the node, should not be considered stable", alias="nodeId")
    results: Optional[Dict[str, SystemCheckResultDTO]] = Field(default=None, description="The system status check results")
    __properties: ClassVar[List[str]] = ["hostname", "nodeId", "results"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SystemCheckResultsApiDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in results (dict)
        _field_dict = {}
        if self.results:
            for _key_results in self.results:
                if self.results[_key_results]:
                    _field_dict[_key_results] = self.results[_key_results].to_dict()
            _dict['results'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SystemCheckResultsApiDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "hostname": obj.get("hostname"),
            "nodeId": obj.get("nodeId"),
            "results": dict(
                (_k, SystemCheckResultDTO.from_dict(_v))
                for _k, _v in obj["results"].items()
            )
            if obj.get("results") is not None
            else None
        })
        return _obj


